diff -ru thuban/Thuban/UI/classifier.py thuban-wx2.5/Thuban/UI/classifier.py
--- thuban/Thuban/UI/classifier.py	2005-01-27 09:19:41.000000000 -0500
+++ thuban-wx2.5/Thuban/UI/classifier.py	2005-01-29 00:55:01.000000000 -0500
@@ -790,7 +790,7 @@
             controlButtonBox.Add(button_moveup, 0, wxGROW|wxALL, 4)
             controlButtonBox.Add(button_movedown, 0, wxGROW|wxALL, 4)
             controlButtonBox.Add(button_edit, 0, wxGROW|wxALL, 4)
-            controlButtonBox.Add(60, 20, 0, wxGROW|wxALL|wxALIGN_BOTTOM, 4)
+            controlButtonBox.Add( (60, 20), 0, wxGROW|wxALL|wxALIGN_BOTTOM, 4)
             controlButtonBox.Add(button_remove, 0, 
                                  wxGROW|wxALL|wxALIGN_BOTTOM, 4)
 
@@ -1407,7 +1407,7 @@
         dc.DestroyClippingRegion()
 
 
-class ClassGroupPropertiesCtrl(wxWindow, wxControl):
+class ClassGroupPropertiesCtrl(wxWindow):
     """A custom window and control that draw a preview of group properties
     and can open a dialog to modify the properties if the user double-clicks
     it.
diff -ru thuban/Thuban/UI/dbdialog.py thuban-wx2.5/Thuban/UI/dbdialog.py
--- thuban/Thuban/UI/dbdialog.py	2004-03-11 16:04:30.000000000 -0500
+++ thuban-wx2.5/Thuban/UI/dbdialog.py	2005-01-29 00:49:55.000000000 -0500
@@ -70,12 +70,12 @@
         # The button box between the connections list box and the table
         # list box
         buttons = wxFlexGridSizer(3, 1, 0, 0)
-        buttons.Add(20, 80, 0, wxEXPAND, 0)
+        buttons.Add( (20, 80), 0, wxEXPAND, 0)
         retrieve_button = wxButton(self, ID_DBCHOOSE_RETRIEVE, _("Retrieve"))
         EVT_BUTTON(self, ID_DBCHOOSE_RETRIEVE, self.OnRetrieve)
         buttons.Add(retrieve_button, 0, wxALL
                     |wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 4)
-        buttons.Add(20, 80, 0, wxEXPAND, 0)
+        buttons.Add( (20, 80), 0, wxEXPAND, 0)
         main_sizer.Add(buttons, 0, wxEXPAND, 0)
 
         # The list box with the tables
diff -ru thuban/Thuban/UI/dock.py thuban-wx2.5/Thuban/UI/dock.py
--- thuban/Thuban/UI/dock.py	2003-07-30 10:43:28.000000000 -0500
+++ thuban-wx2.5/Thuban/UI/dock.py	2005-01-29 00:49:55.000000000 -0500
@@ -375,7 +375,7 @@
         #
         if self.__orientation == wxLAYOUT_VERTICAL:
             headerBox.Add(text, 0, wxALIGN_LEFT | wxALIGN_CENTRE_VERTICAL, 0)
-            headerBox.Add(1, 5, 1, wxGROW)
+            headerBox.Add( (1, 5), 1, wxGROW)
             headerBox.Add(self.__dockButton, 0, wxALIGN_RIGHT, 0)
             headerBox.Add(closeX, 0, wxALIGN_RIGHT | wxLEFT, 4)
         else:
diff -ru thuban/Thuban/UI/legend.py thuban-wx2.5/Thuban/UI/legend.py
--- thuban/Thuban/UI/legend.py	2004-04-18 15:37:45.000000000 -0500
+++ thuban-wx2.5/Thuban/UI/legend.py	2005-01-29 00:51:01.000000000 -0500
@@ -284,7 +284,7 @@
     def find_layer(self, layer):
         """Return the tree item for the layer"""
         root = self.GetRootItem()
-        id, cookie = self.GetFirstChild(root, 0)
+        id, cookie = self.GetFirstChild(root)
         while id.IsOk():
             if self.GetPyData(id) is layer:
                 return id
@@ -487,7 +487,7 @@
         # Build a dict with all layers known by the the tree as keys
         layers = {}
         root = self.GetRootItem()
-        id, cookie = self.GetFirstChild(root, 0)
+        id, cookie = self.GetFirstChild(root)
         while id.IsOk():
             layers[self.GetPyData(id)] = 1
             id, cookie = self.GetNextChild(root, cookie)
@@ -506,7 +506,7 @@
         layers = map.Layers()
 
         root = self.GetRootItem()
-        id, cookie = self.GetFirstChild(root, 0)
+        id, cookie = self.GetFirstChild(root)
         while id.IsOk():
             if self.GetPyData(id) not in layers:
                 self.__RemoveLayer(id)
@@ -569,7 +569,7 @@
 
                     if bmp is None:
                         self.SetItemImage(id, -1)
-                        self.SetItemSelectedImage(id, -1)
+                        #self.SetItemSelectedImage(id, -1)
                     else:
                         if self.availImgListIndices:
                             i = self.availImgListIndices.pop(0)
@@ -578,7 +578,7 @@
                             i = self.image_list.Add(bmp)
 
                         self.SetItemImage(id, i)
-                        self.SetItemSelectedImage(id, i)
+                        #self.SetItemSelectedImage(id, i)
 
         self.Thaw()
 
@@ -598,7 +598,7 @@
 
         pid = self.GetRootItem()
 
-        id, cookie = self.GetFirstChild(pid, 123)
+        id, cookie = self.GetFirstChild(pid)
         while id.IsOk():
             self.__RemoveLayer(id)
             id, cookie = self.GetNextChild(pid, cookie)
@@ -636,7 +636,7 @@
         self.Delete(id)
 
     def DeleteChildren(self, pid):
-        id, cookie = self.GetFirstChild(pid, 123)
+        id, cookie = self.GetFirstChild(pid)
         while id.IsOk():
             self.availImgListIndices.append(self.GetItemImage(id))
             id, cookie = self.GetNextChild(pid, cookie)
@@ -692,7 +692,7 @@
 
         self.__SetVisibilityStyle(visible, parent)
 
-        id, cookie = self.GetFirstChild(parent, 123)
+        id, cookie = self.GetFirstChild(parent)
 
         while id.IsOk():
             self.__SetVisibilityStyle(visible, id)
diff -ru thuban/Thuban/UI/projdialog.py thuban-wx2.5/Thuban/UI/projdialog.py
--- thuban/Thuban/UI/projdialog.py	2004-12-23 10:10:41.000000000 -0500
+++ thuban-wx2.5/Thuban/UI/projdialog.py	2005-01-29 00:49:55.000000000 -0500
@@ -113,12 +113,12 @@
         self.button_export = wxButton(self, ID_PROJ_EXPORT, _("Export..."))
         EVT_BUTTON(self, ID_PROJ_EXPORT, self._OnExport)
         buttons.Add(self.button_export, 1, wxALL|wxEXPAND, 4)
-        buttons.Add(20, 20, 0, wxEXPAND, 0)
+        buttons.Add( (20, 20), 0, wxEXPAND, 0)
         self.button_remove = wxButton(self, ID_PROJ_REMOVE, _("Remove"))
         EVT_BUTTON(self, ID_PROJ_REMOVE, self._OnRemove)
         buttons.Add(self.button_remove, 1, wxALL|wxEXPAND, 4)
 
-        buttons.Add(20, 20, 0, wxEXPAND, 0)
+        buttons.Add( (20, 20), 0, wxEXPAND, 0)
         label = wxStaticText(self, -1, _("Show EPSG:"))
         buttons.Add(label, 0, wxLEFT|wxRIGHT|wxTOP, 4)
         self.check_epsg = wxCheckBox(self, -1, _("Normal"))
@@ -186,7 +186,7 @@
         self.button_add = wxButton(self, ID_PROJ_ADDTOLIST, _("Add to List"))
         EVT_BUTTON(self, ID_PROJ_ADDTOLIST, self._OnAddToList)
         buttons.Add(self.button_add, 0, wxEXPAND|wxALL, 4)
-        buttons.Add(20, 20, 0, wxEXPAND, 0)
+        buttons.Add( (20, 20), 0, wxEXPAND, 0)
         self.button_save = wxButton(self, ID_PROJ_SAVE,_("Update"))
         EVT_BUTTON(self, ID_PROJ_SAVE, self._OnSave)
         buttons.Add(self.button_save, 0, wxEXPAND|wxALL|wxALIGN_BOTTOM, 4)
diff -ru thuban/Thuban/UI/tableview.py thuban-wx2.5/Thuban/UI/tableview.py
--- thuban/Thuban/UI/tableview.py	2003-12-22 09:54:47.000000000 -0500
+++ thuban-wx2.5/Thuban/UI/tableview.py	2005-01-29 00:49:55.000000000 -0500
@@ -408,7 +408,7 @@
         sizer.Add(self.combo_value, 1, wxEXPAND|wxALL, 4)
         sizer.Add(self.choice_action, 0, wxALL, 4)
         sizer.Add(button_query, 0, wxALL | wxALIGN_CENTER_VERTICAL, 4)
-        sizer.Add(40, 20, 0, wxALL, 4)
+        sizer.Add( (40, 20), 0, wxALL, 4)
 
         topBox.Add(sizer, 0, wxEXPAND|wxALL, 4)
         topBox.Add(self.grid, 1, wxEXPAND|wxALL, 0)
@@ -416,7 +416,7 @@
         sizer = wxBoxSizer(wxHORIZONTAL)
         sizer.Add(button_export, 0, wxALL, 4)
         sizer.Add(button_exportSel, 0, wxALL, 4)
-        sizer.Add(60, 20, 1, wxALL|wxEXPAND, 4)
+        sizer.Add( (60, 20), 1, wxALL|wxEXPAND, 4)
         sizer.Add(button_close, 0, wxALL|wxALIGN_RIGHT, 4)
         topBox.Add(sizer, 0, wxALL | wxEXPAND, 4)
 